#-*- coding: utf-8 -*- 
#
# Fichier: Script_TAD_13_Notation_Polonaise.py

# Définition d'une Pile à partir de liste chainée
# Python
# Inspiré de Jean-Pierre Becirspahic
# https://info-llg.fr/commun-mp/pdf/01.piles.pdf
# Revue PG Octobre 2020


# Calcul de la longueur avec une fonction récursive
def longueurRecursif(pile):
    """renvoie la longueur de la pile"""
    if pile is None:
        return 0
    else:
        return 1 + longueurRecursif(pile.next) 

# Impression des éléments de la pile
def imprimeElement(lst):
    """
    Imprime les éléments de la pile
    construction récursive
    """
    if lst is None:
        print("")
    else:
        print(lst.val)
        imprimeElement(lst.next)

        
class Cell:
    def __init__(self,  x):
        self.val  =  x
        self.next  =  None

class Pile:
    def __init__(self):
        self.lst  =  None
    
    def estVide(self):
        return self.lst is None
    
    def empiler(self,  x):
        c  =  Cell(x)
        c.next  =  self.lst
        self.lst  =  c
    
    def depiler(self):
        if self.estVide():
            raise ValueError("pile  vide")
        c  =  self.lst
        self.lst  =  c.next
        return c.val

    def longueur(self):
        """renvoie la longueur de la liste lst"""
        if self.estVide() is None:
            return 0
        else:
            return longueurRecursif(self.lst)

    def afficher(self):
        """afficher le contenu de la pile"""
        imprimeElement(self.lst)          
            

    def __str__(self):
        if self.estVide() is True:
            return "Pile vide"
        else:
            c = self.lst
            return str(c.val)

    def __len__(self):
        """renvoie la longueur de la liste lst"""
        if self.estVide() is None:
            return 0
        else:
            return longueurRecursif(self.lst)


def evaluationPostFixee(expression):
    '''
    Evaluation d'une expression post fixée : notation polonaise inverse
    Pour simplifier les opérandes sont uniquement les chiffres de 0 à 9
    et les opérateurs les opérations + * / -
    '''
    # Création de la pile
    pile = Pile()
    
    # Les chiffres et opérateurs autorisés
    chiffre = {'0','1','2','3','4','5','6','7','8','9'}
    operateur = {'*','/','-','+'}
    
    # Analyse caractère par caractère
    for c in expression:
        if c!=' ':
            if c in chiffre:
                pile.empiler(int(c))
            if c in operateur:
                # A compléter





    return pile.depiler()
            


        
## Utilisation de la classe Pile
print("EVALUATION D'EXPRESSION POSTFIXEE")
print()

expression_1 = "20 3 + 6 *"
print("EXPRESSION 1 : ",expression_1)
print(evaluationPostFixee(expression_1))
print()


expression_2 = "3 4 + 3 2 - *"
print("EXPRESSION 2 : ",expression_2)
print(evaluationPostFixee(expression_2))
print()

 
expression_3 = "2 6 2 * 1 + *"
print("EXPRESSION 3 : ",expression_3)
print(evaluationPostFixee(expression_3))
print()

 
expression_4 = "2 3 + 7 9 - 4 * +"
print("EXPRESSION 4 : ",expression_4)
print(evaluationPostFixee(expression_4))
print()  